%-------DIPLOMOV PRCE---------
% ====================================
% LOHA PROUDN CHLADIVA V PALIVOVM SOUBORU EEN SUBKANLOVOU ANALZOU
% ====================================
% Autor: Marek Blohoubek
% Verze: 1.0
% Datum: 2020
% ====================================
% <<<<<< INPUTS
% M,W,h,p,rho,u,T - pole vstupnch veliin subkanlov analzy
% c1,c2,vd - pomocn geometrick parametry
% volba,vrstva - parametry pro vykreslen pole vstupn veliiny
% smerodatnaOdchylka - hodnoty smrodatnch odchylek pro jejich vykreslen
% >>>>>> OUTPUTS
% grafick vstupy  - pole vybran veliiny na vstupu
%                   - prbh teploty a tlaku po dlce souboru 
%                   - vyhodnocen koef. beta men

clc
%clear all
close all

%-------pomocn geometrick parametry---------
c1=(vh/2)/(tan(pi/3)); %pomocn rozmry kvli vykreslovn [m]
c2=a*cos(pi/3);
vd=4*a+2*(s1+d/2); %ka kazety [mm]

%-------deklarace matice vrchol (pro vykreslen)--------
%struktura: | x-ov sou. | y-ov sou. |
pocetVrcholu=31;
pocetProutku=19; %roven potu vnitnch vrchol
vrcholy=zeros(3,pocetVrcholu);

stridani1=[3 4 5 4 3; (vhr/2-a)+c1 (vhr/2-a)+c1-c2 (vhr/2-a)+c1-2*c2 (vhr/2-a)+c1-c2 (vhr/2-a)+c1]; %y-ov vrstva vnitnch prvku | x-ov sou. pinleejc dan vrstv
stridani2=[3 2 2 2 3; c1 c1/2 0 c1/2 c1]; %y-ov vrstva vnjch prvku

pom1=0;
pom2=0;

vrstva1=0;
vrstva2=0;

for ii=1:pocetVrcholu
    if ii<=pocetProutku %vnitn subkanly
        vrcholy(1,ii)=stridani1(2,vrstva1+1)+pom1*a;
        vrcholy(2,ii)=a2+vrstva1*a1;
        pom1=pom1+1;
        if pom1>=stridani1(1,vrstva1+1)
            pom1=0;
            vrstva1=vrstva1+1;
        end
    else %vnj subkanly
        vrcholy(1,ii)=stridani2(2,vrstva2+1)+pom2*vhr/2;
        vrcholy(2,ii)=(vh/4)*vrstva2;
        pom2=pom2+1;
        if pom2>=stridani2(1,vrstva2+1)
            pom2=0;
            vrstva2=vrstva2+1;
        end
    end
end

%run oprava nkolika prvk
vrcholy(1,24)=vd-c1/2;
vrcholy(1,26)=vd;
vrcholy(1,28)=vd-c1/2;

%-------deklarace matice vrchol pinleejc subkanlm--------
vrchSubkanaly=[10 14 15 0; 10 15 11 0; 10 11 6 0; 10 6 5 0; 10 5 9 0; 10 9 14 0; 14 17 18 0; 14 18 15 0; ...
    15 18 19 0; 15 19 16 0; 11 15 16 0; 11 16 12 0; 11 12 7 0; 6 7 11 0; 6 7 3 0; 6 3 2 0; 2 5 6 0; 1 2 5 0; ...
    1 4 5 0; 4 5 9 0; 4 8 9 0; 8 9 13 0; 9 13 14 0; 13 14 17 0; 17 18 30 29; 18 19 31 30; 19 16 28 31; ...
    16 12 26 28; 12 7 24 26; 7 24 22 3; 2 3 22 21; 1 2 21 20; 1 20 23 4; 8 4 23 25; 13 8 25 27; 17 13 27 29];

%-------------------------------------------------------------------------------
%-------vykreslen zkladn geometrie--------
figure
for ii=1:pocetSubkanalu
    if vrchSubkanaly(ii,4)==0 %vnitn subkanl
        for ij=1:3
            pocx=vrcholy(1,vrchSubkanaly(ii,ij)); %po.x-ov sou.
            pocy=vrcholy(2,vrchSubkanaly(ii,ij)); %po.y-ov sou.
            if ij==3
                koncx=vrcholy(1,vrchSubkanaly(ii,1));
                koncy=vrcholy(2,vrchSubkanaly(ii,1));
            else
                koncx=vrcholy(1,vrchSubkanaly(ii,ij+1)); %konc.x-ov sou.
                koncy=vrcholy(2,vrchSubkanaly(ii,ij+1)); %konc.y-ov sou.
            end
            plot([pocx koncx],[pocy koncy],'k')
            hold on
        end
    else %vnj subkanl
        for ij=1:4
            pocx=vrcholy(1,vrchSubkanaly(ii,ij)); %po.x-ov sou.
            pocy=vrcholy(2,vrchSubkanaly(ii,ij)); %po.y-ov sou.
            if ij==4
                koncx=vrcholy(1,vrchSubkanaly(ii,1));
                koncy=vrcholy(2,vrchSubkanaly(ii,1));
            else
                koncx=vrcholy(1,vrchSubkanaly(ii,ij+1)); %konc.x-ov sou.
                koncy=vrcholy(2,vrchSubkanaly(ii,ij+1)); %konc.y-ov sou.
            end
            plot([pocx koncx],[pocy koncy],'k')
            hold on
        end
    end
end

for ii=1:pocetProutku
    t=0:.1:2*pi;
    r=d/2; %polomr palivovho proutku
    patch(r*sin(t)+vrcholy(1,ii),r*cos(t)+vrcholy(2,ii),'white')
    hold on
end

xlabel('Souadnice x [m]')
ylabel('Souadnice y [m]')
upravaGrafu(0,0);

%-------------------------------------------------------------------------------
%-------rozloen zadan veliiny v rmci geometrie a pro zvolenou hodnotu y--------
volba=5; %uren vykreslovan veliiny
vrstva=length(T); %uren zobrazovan prostorov vrstvy (obvykle na vstupu)
% vrstva=110;
switch volba
    case 1
        velicina=W(:,vrstva);
    case 2
        velicina=p(:,vrstva);
    case 3
        velicina=h(:,vrstva);
    case 4
        velicina=M(:,vrstva);
    case 5
        velicina=T(:,vrstva);
    case 6
        velicina=rho(:,vrstva);
    case 7
        velicina=TrealMereni';
    otherwise
        velicina=u(:,vrstva);
end

%pepoet hmotnostnho toku (nyn) vztaen na prtonou plochu [kg /s m2]
if volba==4
    for ii=1:length(velicina)
        if ii<=24
            velicina(ii)=velicina(ii)/Ai;
        else
            velicina(ii)=velicina(ii)/Ao;
        end
    end
end

%aproximace veliin pro dan vrcholy
for ii=1:pocetVrcholu
    hledane=find(vrchSubkanaly==ii);
    hledane=mod(hledane,pocetSubkanalu);
    for ij=1:length(hledane)
        if hledane(ij)==0
            hledane(ij)=pocetSubkanalu;
        end
        vrcholy(3,ii)=vrcholy(3,ii)+velicina(hledane(ij));
    end
    
    vrcholy(3,ii)=vrcholy(3,ii)/length(hledane);
end

%-------------------------------------------------------------------------------
%vykreslen rozloen veliiny v rmci geometrie
opravy=[25 26 27 30 31 32 33 36; 7 9 9 16 16 18 18 7; 0 0 1 1 0 0 1 1]; %matice oprav vykreslovn 
        %struktura:| slo opravenho prvku | slo vzorovho prvku | x/y-ov sou. (0/1)|
figure
for ii=1:pocetSubkanalu
    if vrchSubkanaly(ii,4)==0 %vnitn subkanl
        x1=vrcholy(1,vrchSubkanaly(ii,1));
        x2=vrcholy(1,vrchSubkanaly(ii,2));
        x3=vrcholy(1,vrchSubkanaly(ii,3));
        
        y1=vrcholy(2,vrchSubkanaly(ii,1));
        y2=vrcholy(2,vrchSubkanaly(ii,2));
        y3=vrcholy(2,vrchSubkanaly(ii,3));
        
        z1=vrcholy(3,vrchSubkanaly(ii,1));
        z2=vrcholy(3,vrchSubkanaly(ii,2));
        z3=vrcholy(3,vrchSubkanaly(ii,3));
        
        patch([x1 0; x2 0; x3 0],[y1 0; y2 0; y3 0],[z1 0;z2 0; z3 0])
        switch volba
            case 2
                txt = num2str(velicina(ii),'%2.0f');
            case 8
                txt = num2str(velicina(ii),'%.3f');
            otherwise
                txt = num2str(velicina(ii),'%.1f');
        end
        text((x1+x2+x3)/3,(y1+y2+y3)/3,txt, 'FontSize',12,'HorizontalAlignment','Center', 'Color', 'w')
        hold on
        
    else %vnj subkanl
        x1=vrcholy(1,vrchSubkanaly(ii,1));
        x2=vrcholy(1,vrchSubkanaly(ii,2));
        x3=vrcholy(1,vrchSubkanaly(ii,3));
        x4=vrcholy(1,vrchSubkanaly(ii,4));
        
        y1=vrcholy(2,vrchSubkanaly(ii,1));
        y2=vrcholy(2,vrchSubkanaly(ii,2));
        y3=vrcholy(2,vrchSubkanaly(ii,3));
        y4=vrcholy(2,vrchSubkanaly(ii,4));
        
        z1=vrcholy(3,vrchSubkanaly(ii,1));
        z2=vrcholy(3,vrchSubkanaly(ii,2));
        z3=vrcholy(3,vrchSubkanaly(ii,3));
        z4=vrcholy(3,vrchSubkanaly(ii,4));
        
        patch([x1 0; x2 0; x3 0; x4 0],[y1 0; y2 0; y3 0; y4 0],[z1 0;z2 0; z3 0; z4 0])
        switch volba
            case 2
                txt = num2str(velicina(ii),'%2.0f');
            case 8
                txt = num2str(velicina(ii),'%.3f');
            otherwise
                txt = num2str(velicina(ii),'%.1f');
        end
        
        nasel=0;
        for ij=1:length(opravy)
            if opravy(1,ij)==ii
                nasel=1;
                break;
            end
        end
        if nasel==1 %run oprava vykreslovn nkterch prvk
            if opravy(3,ij)==0
                umistenix=vrcholy(1,vrchSubkanaly(opravy(2,ij),1))+...
                    vrcholy(1,vrchSubkanaly(opravy(2,ij),2))+vrcholy(1,vrchSubkanaly(opravy(2,ij),3));
                text(umistenix/3,(y1+y2+y3+y4)/4,txt, 'FontSize',12,'HorizontalAlignment','Center', 'Color', 'w')
            else
                umisteniy=vrcholy(2,vrchSubkanaly(opravy(2,ij),1))+...
                    vrcholy(2,vrchSubkanaly(opravy(2,ij),2))+vrcholy(2,vrchSubkanaly(opravy(2,ij),3));
                text((x1+x2+x3+x4)/4,umisteniy/3,txt, 'FontSize',12,'HorizontalAlignment','Center', 'Color', 'w')
            end
        else
            text((x1+x2+x3+x4)/4,(y1+y2+y3+y4)/4,txt, 'FontSize',12,'HorizontalAlignment','Center', 'Color', 'w')
        end
        hold on
    end
end

poradiProutky=[16 15 14 17 6 5 13 18 7 1 4 12 19 2 3 11 8 9 10];
%Poad proutk v relaci s vykreslovanmi vrcholy

for ii=1:pocetProutku
    t=0:.1:2*pi;
    r=d/2; %polomr proutku
    patch(r*sin(t)+vrcholy(1,ii),r*cos(t)+vrcholy(2,ii),'white')
    txt = num2str(vykon(poradiProutky(ii))/prevod,'%.3f'); %vypsn relativn hodnoty vkonu do kadho proutku
    text(vrcholy(1,ii),vrcholy(2,ii),txt, 'FontSize',12,'HorizontalAlignment','Center', 'Color', 'k')
    hold on
end

col=colorbar;
colormap jet;
xlabel('Souadnice x [m]')
ylabel('Souadnice y [m]')
caxis([min(velicina) max(velicina)])

switch volba
    case 1
        %title(sprintf('Rozloen veliiny W v rmci geomtrie v ezu h= %.3f m', h));
        set(get(col,'title'),'string','[kg\cdot s^{-1}\cdot m^{-1}]');
    case 2
        %title(sprintf('Rozloen veliiny p v rmci geomtrie v ezu h= %.3f m', h));
        set(get(col,'title'),'string','[Pa]');
        aktualniVzdalenost=(vrstva*dy-mrizkyMisici(1))*1000;
        jmeno=['y = ',int2str(aktualniVzdalenost),' mm'];
        text(0.02,0.98,jmeno,'Units','normalized','FontSize',20)
    case 3
        %title(sprintf('Rozloen veliiny en v rmci geomtrie v ezu h= %.3f m', h));
        set(get(col,'title'),'string','[J\cdot kg^{-1}]');
    case 4
        %title(sprintf('Rozloen veliiny M v rmci geomtrie v ezu h= %.3f m', h));
        set(get(col,'title'),'string','[kg\cdot s^{-1}\cdot m^{-2}]');
    case 5
        %title(sprintf('Rozloen veliiny T v rmci geomtrie v ezu h= %.3f m', h));
        set(get(col,'title'),'string','[^oC]');
    case 6
        %title(sprintf('Rozloen veliiny rho v rmci geomtrie v ezu h= %.3f m', h));
        set(get(col,'title'),'string','[kg\cdot m^{-3}]');
    case 7
        %title(sprintf('Rozloen reln teploty T v rmci geomtrie v ezu h= %.3f m', h));
        set(get(col,'title'),'string','[^oC]');
    otherwise
        %title(sprintf('Rozloen veliiny u v rmci geomtrie v ezu h= %.3f m', h));
        set(get(col,'title'),'string','[m\cdot s^{-1}]');
end
set(gcf,'units','points','position',[0,0,720,720])
upravaGrafu(0,0);
% jmeno=['poleTlaku',int2str((vrstva*dy-mrizkyMisici(1))*1000)];
% print(jmeno,'-dpng');

%-------------------------------------------------------------------------------
%-------Vykreslen prbhu tlaku ve vybranm subkanlu--------------
figure
subkanal=1;
plot(y,p(subkanal,:),'LineWidth',2)
%title(sprintf('Prbh tlaku v zvislosti na ax. souadnici pro %.0f. subkanl', subkanal))
xlabel('Axiln souadnice y [m]')
ylabel('Tlak p [Pa]')
xlim([y(1) y(end)]);
upravaGrafu(0,0);

%-------------------------------------------------------------------------------
%vykreslen prbhu teploty ve vybranch subkanlech
subkanaly=[25 8 1 4 17 31]; %smr gradientu teploty

figure
Legend=cell(length(subkanaly),1);  %generovn legendy s promnnm potem prvk
for ii=1:length(subkanaly)
    plot(y,T(subkanaly(ii),:),'LineWidth',2)
    Legend{ii}=strcat(['sub. ', num2str(subkanaly(ii))]);
    hold on
end

xlabel('Axiln souadnice y [m]')
ylabel('Teplota T [^oC]')
xlim([y(1) y(end)])
ylim([min(T(subkanaly(1),:)) max(T(subkanaly(1),:))*1.05])
%title('Prbh teploty T v podlnm smru u vybranch subkanl')
leg=legend(Legend,'Location','northwest','NumColumns',2);
upravaGrafu(1,leg);

%-------------------------------------------------------------------------------
%vykreslen prbhu pnch tok ve vybranch subkanlech
figure
for ii=1:length(W(:,1))
    plot(y,W(ii,:),'LineWidth',1)
    hold on
end

xlabel('Axiln souadnice y [m]')
ylabel('Pn tok w [kg\cdot s^{-1}\cdot m^{-1}]')
xlim([y(1) y(end)])
% ylim([min(T(subkanaly(1),:)) max(T(subkanaly(1),:))*1.05])
%title('Prbh teploty T v podlnm smru u vybranch subkanl')
% leg=legend(Legend,'NumColumns',2);
upravaGrafu(1,leg);

%-------------------------------------------------------------------------------
%-------Vyhodnocen vlivu konstanty beta-men na pesnost dat-----------
n3=2;
% dbeta=0.3;
% Odchylka=[0.0549029357692236 0.0546519555309935	0.0544989451622792...
%    0.0543502624045804 0.0543184628971191 0.0543371738057164...
%    0.0543560988258444 0.0543864627274978 0.0544139373409384]; %beta1=0.1,
%    dbeta=0.25
% Odchylka=[0.0543968849548314 0.0544198735116523	0.0543088595871499...
%     0.0543544931357327 0.0544105212350746 0.0544149049167567]; %beta1=0.11, dbeta=0.25
% Odchylka=[0.0543444605164369 0.0543179340199235 0.0544155142644479...
%     0.0544180007623195 0.0545021575703378]; %beta1=0.11, dbeta=0.4
% Odchylka=[0.0543976890657545 0.0543883757456194 0.0543496490448504...
%     0.0543486211898516 0.0544149049167567]; %dbeta=0.11,dbeta=0.3
% Odchylka=[0.0542607163355427 0.0543487746132548 0.0544344093469813...
%     0.0545481696948878 0.0544530433696205 0.0544445227027708]; %beta1=0.12

% betaMiseni=zeros(1,length(Odchylka));
% for ii=1:length(Odchylka)
%     betaMiseni(ii)=dbeta+(ii-1)*dbeta;
% end

%finln vbr
betaMiseni=[0.1 0.4 0.8 1.2 1.5];
Odchylka=[0.0544290987367316 0.0543444605164369 0.0543179340199235...
    0.054348621189851 0.0544149049167567];

betaProloz=betaMiseni(1)-0.1:.01:betaMiseni(end)+0.1;
p3=polyfit(betaMiseni,Odchylka,n3);
y3=polyval(p3,betaProloz);

%vykreslen smr. odchylek beta-men
figure
plot(betaMiseni,Odchylka,'x','LineWidth',3,'MarkerSize',20)
hold on
plot(betaProloz,y3,'LineWidth',2)
leg=legend('Prokldan hodnoty','Proloen polynomem 2.stupn');
xlabel('Souinitel turbulentnho men \beta [-]');
ylabel('Smrodatn odchylka S_{\Sigma} [-]');
%title('Vsledky verifikace hodnot teploty pro rzn nastaven koef. \beta men');
%axis([betaProloz(1) betaProloz(end), min(y3)-0.02 max(y3)+0.02])
upravaGrafu(1,leg);

minOdchylkaBeta=min(y3);
indexMin=find(y3==minOdchylkaBeta);
minBeta=betaProloz(indexMin);
disp(minBeta);

% %-------------------------------------------------------------------------------
% %vykreslen prbhu teploty ve vech subkanlech
% figure
% for ii=1:pocetSubkanalu
%     plot(y,T(ii,:),'LineWidth',2)
%     hold on
% end
% 
% xlabel('Axiln vzdlenost y [m]')
% ylabel('Teplota T [^oC]')
% %title('Prbh teploty T v podlnm smru ve vech subkanlech')
% upravaGrafu(0,0);